using System;
using System.Collections.Generic;
using System.Text;
using System.IO ;
using System.Windows.Forms ;

namespace SanwaNewtec.Demonstrate.SampleRWControlCS.Common
{

  public class ComDef
  {
    public static bool IsBw(byte value, byte min, byte max )
    {
      return (value>= min )&& (value<= max ) ;
    }

    public static bool __ismbbkana(byte c )
    {
      return IsBw(c, 0xA6, 0xDF )
        ||   IsBw(c, 0xA1, 0xA5 ) ;  
    }    
    public static bool __ismbblead(byte c )
    {
      return IsBw(c, 0x81, 0x9F )
        ||   IsBw(c, 0xE0, 0xFC ) ;  
    }
    public static bool __ismbbtrail(byte c )
    {
      return IsBw(c, 0x40, 0x7E )
        ||   IsBw(c, 0x80, 0xFC ) ;
    }
    public static bool __ismbbprint(byte c )
    {
      return _isprint( c )|| __ismbbkana( c ) ;
    }
    public static bool _isprint(byte c )
    {
      return IsBw(c, 0x20, 0x7E ) ;
    }
    public static bool _isdigit(byte c )
    {
      return IsBw(c, 0x30, 0x39 ) ;
    }
    public static bool _isxdigt(byte c )
    {
      return IsBw(c, 0x41, 0x46 )
        ||   IsBw(c, 0x61, 0x66 )
        ||   IsBw(c, 0x30, 0x39 ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ^ꂽpǂԂ
    /// </summary>
    /// <param name="c"></param>
    /// <returns></returns>
    public static bool _islower(byte c )
    {
      return IsBw(c, 0x61, 0x7A ) ;
    }
    public static bool _isspc20(byte c )
    {
      return (c== 0x20 ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ŗ^ꂽpł΁Ap啶ɕϊĕԂ
    /// </summary>
    /// <param name="c"></param>
    /// <returns></returns>
    public static byte ToUpper(byte c )
    {
      return _islower( c )? (byte)(c- 0x20 ): c ;
    }
    public static string CC(byte[] bytes )
    {
      string rc= "" ; // return code of this proc
      //
      if(bytes== null ) throw new ArgumentNullException() ;
      else {
        int i3= bytes.Length ;
        if(i3!= 0 ){
          Encoding sjis= Encoding.GetEncoding( 932 ) ;
          int    cx= 0 ;
          int    sp= 0 ;
          byte[] c = new byte[2] ;
          string header= "" ;
          string guide = "" ;
          string body  = "" ;
          //
          do {
            byte mod= (byte)(cx% 16 ) ;
            if(mod== 0 || ((mod== 1 )&& (sp== 2 ) ) ){
              header= string.Format("  {0:X6}", cx ) ;
              if(mod== 0 ){
                body = "" ;
                guide= "" ;
              }else {
                body= string.Format("{0:X2} ", c[1] ) ;
                guide= " " ;
              }
            }else if(mod== 8 ){
              guide+= " " ;
            }
            // ]镶̐؂o
            c[0]= bytes[cx ] ;
            c[1]= 0 ;
            if((cx+ 1 )< i3 ) c[1]= bytes[cx+ 1 ] ;
            sp= 0 ;
            if(__ismbblead( c[0] )&& __ismbbtrail( c[1] ) ) sp= 2 ;
            else if(__ismbbprint( c[0] ) ) sp= 1 ;
            if(sp!= 0 ) guide+= sjis.GetString(c, 0, sp ) ;
            else {
              sp= 1 ;
              guide+= "." ;
            }
            if(sp== 2 ){
              if(mod== 15 ){
                body+= string.Format("{0:X2} ", c[0] ) ;
              }else {
                body+= string.Format("{0:X2} {1:X2} ", c[0], c[1] ) ;
              }
            }else {
              body+= string.Format("{0:X2} ", c[0] ) ;
            }
            if((mod+ sp )> 15 ){
              body= body.TrimEnd(new char[]{' ' } ) ;
              rc+= string.Format("{0} {1,-47} {2}", header, body, guide)+ "\r\n" ;
            }
            cx+= sp ;
          }while(cx< i3 ) ;
          if((i3% 16 )!= 0 ){
            rc+= string.Format("{0} {1,-47} {2}", header, body, guide )+ "\r\n" ;
          }
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ŗ^16izoCgɕϊ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="strs"></param>
    /// <returns></returns>
    public static byte[] ToBinaryFromHexStrings(string[] strs )
    {
      byte[] rc= new byte[0] ; // return code of this proc 
      //
      if(strs== null ) throw new ArgumentNullException() ;
      else {
        foreach(string str in strs ){
          byte[] tmp= ToBinaryFromHexString( str ) ;
          if(tmp.Length!= 0 ){
            byte[] buf= new byte[rc.Length+ tmp.Length ] ;
            Array.Copy(rc, buf, rc.Length ) ;
            Array.Copy(tmp, 0, buf,rc.Length, tmp.Length ) ;
            rc= buf ;
          }
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ŗ^zCP-932ɃGR[hoCgɕϊ
    /// ύX
    ///   2006/10/26 ( kw )    
    /// </summary>
    /// <param name="strs"></param>
    /// <returns></returns>
    public static byte[] ToBinaryFromStrings(string[] strs )
    {
      byte[] rc= new byte[0] ; // return code of this proc 
      //
      if(strs== null ) throw new ArgumentNullException() ;
      else {
        foreach(string str in strs ){
          byte[] tmp= ToBinaryFromString( str ) ;
          if(tmp.Length!= 0 ){
            byte[] buf= new byte[rc.Length+ tmp.Length ] ;
            Array.Copy(rc, buf, rc.Length ) ;
            Array.Copy(tmp, 0, buf,rc.Length, tmp.Length ) ;
            rc= buf ;
          }
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ŗ^CP-932ɃGR[hoCgɕϊ
    /// ύX
    ///   2006/10/26 ( kw )    
    /// </summary>
    /// <param name="str"></param>
    /// <returns></returns>
    public static byte[] ToBinaryFromString(string str )
    {
      byte[] rc= new byte[0] ;
      //
      if(str== null ) throw new ArgumentNullException() ;
      else {
        if(str.Length!= 0 ){
          Encoding cp932= Encoding.GetEncoding(932 ) ;
          rc= cp932.GetBytes( str ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ŗ^ꂽp16ioCgɕϊ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="str"></param>
    /// <returns></returns>
    public static byte[] ToBinaryFromHexString(string str )
    {
      byte[] rc= new byte[0] ;
      //
      if(str== null ) throw new ArgumentNullException() ;
      else {
        if(str.Length!= 0 ){
          Encoding cp932= Encoding.GetEncoding( 932 ) ;
          byte[] src= cp932.GetBytes( str ) ; 
          int    i3 = src.Length ;
          byte[] dst= new byte[i3 ] ;
          int    cx = 0 ;
          byte   d  = 0 ;
          bool   flg= false ;
          ///
          for(int i= 0; i< i3; i++ ){
            byte c= ToUpper( src[i] ) ;
            if(!_isspc20( c )&& !_isxdigt( c ) ) throw new FormatException() ;
            else {
              if(_isxdigt( c ) ){
                if(_isdigit( c ) ) c= (byte)(c- 0x30 ) ;
                else               c= (byte)(c- 0x37 ) ;
                d= (byte)(d* 16+ c ) ;
                if(!flg ) flg= true ;
                else {
                  dst[cx++ ]= d ;
                  d  = 0 ; 
                  flg= false ;
                }
              }
            }
          }
          if(flg ) dst[cx++ ]= d ;
          if(cx== 0 ) throw new ArgumentException() ;
          else {
            rc= new byte[cx ] ;
            Array.Copy(dst, rc, cx ) ;
          }
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="data"></param>
    /// <returns></returns>
    public static string[] ToHexStringsFromBinary(byte[] data)
    {
      string[] rc= new string[0] ; // return code of this proc
      ///
      if(data== null ) throw new ArgumentNullException() ;
      else {
        int i3= data.Length ;
        if(i3!= 0 ){
          List<string> buf= new List<string>() ;
          string s= "" ;
          for(int i= 0; i< i3; i++ ){
            if((i% 16 )!= 15 ) s+= string.Format("{0:X2} ", data[i] ) ;
            else {
              s+= string.Format("{0:X2}", data[i] ) ;
              buf.Add( s ) ;
              s= "" ;
            }
          }
          if((i3% 16 )!= 0 ){
            buf.Add( s ) ;
          }
          rc= new string[buf.Count ] ;
          buf.CopyTo(rc ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ŗ^ꂽt@Crbg}bvt@CǂAgqŔ肵ČʂԂ
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="fileName"></param>
    /// <returns></returns>
    public static bool IsBitmapFileName(string fileName )
    {
      return (Path.GetExtension(fileName ).ToLower()== _bitmapExt ) ;
    }
    const string _bitmapExt=".bmp";
    ///*************************************************************************************************
    /// <summary>
    /// mF_CAO\AIy[^̎w
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="msg"></param>
    /// <param name="caption"></param>
    /// <returns></returns>
    public static bool QMbxYesNo(string msg, string caption )
    {
      return (MessageBox.Show(msg, caption, MessageBoxButtons.YesNo, MessageBoxIcon.Question )== DialogResult.Yes ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// x_CAO\AG[Iy[^ɒʒm
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="msg"></param>
    /// <param name="caption"></param>
    public static void EMbxOk(string msg, string caption )
    {
      MessageBox.Show(msg, caption, MessageBoxButtons.OK, MessageBoxIcon.Error ) ;
    }
    public static void IMbxOk(string msg, string caption )
    {
      MessageBox.Show(msg, caption, MessageBoxButtons.OK, MessageBoxIcon.Information ) ;
    }

    #region  2014/10/23  ǉ
    /// <summary>
    /// bytez𕶎ɕϊ
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="value">f[^</param>
    /// <returns>f[^</returns>
    public static string  ByteToString( byte[]  value )
    {
      string         ret = string.Empty;
      StringBuilder  node = new StringBuilder();
      int            len = (int)0;

      if( value.Length > (int)0 )
      {
        len = value.Length;
        for( int  i = 0; i < len; i++ )
        {
          node.Append( string.Format( "{0:X2} ",
                                      value[ i ] ) );
        }
        ret = node.ToString();
        if( ret[ ret.Length / 3 ] != ' ' )
        {
          ret = ret.Substring( 0,
                               ( node.ToString().Length - 1 ) );
        }
      }

      return ( ret );
    }

    /// <summary>
    /// bytezɕϊ
    ///   (f[^́A123ABC EEE̗lɎw肷邱)
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="value">f[^</param>
    /// <remarks>f[^́A123ABC EEE̗lɎw肷邱</remarks>
    /// <returns>oCgzf[^</returns>
    public static byte[]  CharToBytes( string  value )
    {
      byte[]  ret = null;
      int     len = (int)0;

      if( value.Length > (int)0 )
      {
        ret = Encoding.GetEncoding( 932 ).GetBytes( value );
        len = Encoding.GetEncoding( 932 ).GetByteCount( value );
      }

      return ( ret );
    }

    /// <summary>
    /// 16i`bytezɕϊ
    ///   (f[^́A31 32 33 EEE̗lɎw肷邱)
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="value">f[^</param>
    /// <remarks>f[^́A31 32 33 EEE̗lɎw肷邱</remarks>
    /// <returns>oCgzf[^</returns>
    public static byte[] HexToBytes( string value )
    {
      byte[]  ret = null;
      int     i = (int)0;
      int     len = (int)0;
      string  s = string.Empty;

      if( value.Length > (int)0 )
      {
        len = (int)( ( value.Length / 3 ) + 1 );
        ret = new byte[ len ];
        for( i = (int)0; i < len; i++ )
        {
          s = string.Format( "0x{0:X2}",
                             value.Substring( ( i * 3 ), 2 ) );
          ret[ i ] = Convert.ToByte( s, 16 );  //16ix[Xbyte^ɕϊ
        }
      }

      return ( ret );
    }

    /// <summary>
    /// ė̊YL[𖳌ɂ
    /// </summary>
    /// <param name="e"></param>
    /// <param name="key"></param>
    public static void DisableKeyPress( KeyPressEventArgs e,
                                        Keys key )
    {
      if( e.KeyChar == (char)key )
      {
        e.Handled = true;
      }
    }

    /// <summary>
    /// ̊YL[𖳌ɂ
    /// </summary>
    /// <param name="e"></param>
    /// <param name="key"></param>
    public static void DisableKeyDown( KeyEventArgs e,
                                       Keys key )
    {
      if( e.KeyCode == key )
      {
        e.SuppressKeyPress = true;
      }
    }
    #endregion  2014/10/23  ǉ

  }

}
